// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from naoqi_bridge_msgs:msg/WordRecognized.idl
// generated code does not contain a copyright notice
#include "naoqi_bridge_msgs/msg/detail/word_recognized__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "naoqi_bridge_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "naoqi_bridge_msgs/msg/detail/word_recognized__struct.h"
#include "naoqi_bridge_msgs/msg/detail/word_recognized__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "rosidl_runtime_c/primitives_sequence.h"  // confidence_values
#include "rosidl_runtime_c/primitives_sequence_functions.h"  // confidence_values
#include "rosidl_runtime_c/string.h"  // words
#include "rosidl_runtime_c/string_functions.h"  // words

// forward declare type support functions


using _WordRecognized__ros_msg_type = naoqi_bridge_msgs__msg__WordRecognized;

static bool _WordRecognized__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _WordRecognized__ros_msg_type * ros_message = static_cast<const _WordRecognized__ros_msg_type *>(untyped_ros_message);
  // Field name: words
  {
    size_t size = ros_message->words.size;
    auto array_ptr = ros_message->words.data;
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; ++i) {
      const rosidl_runtime_c__String * str = &array_ptr[i];
      if (str->capacity == 0 || str->capacity <= str->size) {
        fprintf(stderr, "string capacity not greater than size\n");
        return false;
      }
      if (str->data[str->size] != '\0') {
        fprintf(stderr, "string not null-terminated\n");
        return false;
      }
      cdr << str->data;
    }
  }

  // Field name: confidence_values
  {
    size_t size = ros_message->confidence_values.size;
    auto array_ptr = ros_message->confidence_values.data;
    cdr << static_cast<uint32_t>(size);
    cdr.serializeArray(array_ptr, size);
  }

  return true;
}

static bool _WordRecognized__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _WordRecognized__ros_msg_type * ros_message = static_cast<_WordRecognized__ros_msg_type *>(untyped_ros_message);
  // Field name: words
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->words.data) {
      rosidl_runtime_c__String__Sequence__fini(&ros_message->words);
    }
    if (!rosidl_runtime_c__String__Sequence__init(&ros_message->words, size)) {
      fprintf(stderr, "failed to create array for field 'words'");
      return false;
    }
    auto array_ptr = ros_message->words.data;
    for (size_t i = 0; i < size; ++i) {
      std::string tmp;
      cdr >> tmp;
      auto & ros_i = array_ptr[i];
      if (!ros_i.data) {
        rosidl_runtime_c__String__init(&ros_i);
      }
      bool succeeded = rosidl_runtime_c__String__assign(
        &ros_i,
        tmp.c_str());
      if (!succeeded) {
        fprintf(stderr, "failed to assign string into field 'words'\n");
        return false;
      }
    }
  }

  // Field name: confidence_values
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->confidence_values.data) {
      rosidl_runtime_c__float__Sequence__fini(&ros_message->confidence_values);
    }
    if (!rosidl_runtime_c__float__Sequence__init(&ros_message->confidence_values, size)) {
      fprintf(stderr, "failed to create array for field 'confidence_values'");
      return false;
    }
    auto array_ptr = ros_message->confidence_values.data;
    cdr.deserializeArray(array_ptr, size);
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_naoqi_bridge_msgs
size_t get_serialized_size_naoqi_bridge_msgs__msg__WordRecognized(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _WordRecognized__ros_msg_type * ros_message = static_cast<const _WordRecognized__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name words
  {
    size_t array_size = ros_message->words.size;
    auto array_ptr = ros_message->words.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        (array_ptr[index].size + 1);
    }
  }
  // field.name confidence_values
  {
    size_t array_size = ros_message->confidence_values.size;
    auto array_ptr = ros_message->confidence_values.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    (void)array_ptr;
    size_t item_size = sizeof(array_ptr[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

static uint32_t _WordRecognized__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_naoqi_bridge_msgs__msg__WordRecognized(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_naoqi_bridge_msgs
size_t max_serialized_size_naoqi_bridge_msgs__msg__WordRecognized(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: words
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }
  // member: confidence_values
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  return current_alignment - initial_alignment;
}

static size_t _WordRecognized__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_naoqi_bridge_msgs__msg__WordRecognized(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_WordRecognized = {
  "naoqi_bridge_msgs::msg",
  "WordRecognized",
  _WordRecognized__cdr_serialize,
  _WordRecognized__cdr_deserialize,
  _WordRecognized__get_serialized_size,
  _WordRecognized__max_serialized_size
};

static rosidl_message_type_support_t _WordRecognized__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_WordRecognized,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, naoqi_bridge_msgs, msg, WordRecognized)() {
  return &_WordRecognized__type_support;
}

#if defined(__cplusplus)
}
#endif
